// MyReader.java

import java.io.*;
import java.util.*;

/**
 * A static class to simplify reading operations in ESFrameModelSwarm.java
 * and in UnitParameters.java
 * @author Pietro Terna
 */
public class MyReader
{
    /** check if it is necessary to read a new line and do it */
    public static StringTokenizer check(String fileUnit,
					BufferedReader file,
					String line,
					StringTokenizer t)
    {
	try
	    {
		// the while structure deals with the empty lines case
		while (! t.hasMoreTokens())
		    {
			line = file.readLine();
			if (line==null)
			    {
				// EOF case
				System.out.println(
				   "Missing data in file: " + fileUnit);
				MyExit.exit(1);
			    }
			line=line.replace('\t',' ');
			t = new StringTokenizer(line, " ");
		    }
	    }
       	catch (IOException e)
	    {
		System.out.println("IOException:" + e.toString());
	    }

	return t;
    }

    /** check if it is necessary to read a new line and do it, returning a null
     *  value if we are at the eof */
    public static StringTokenizer check_with_eof(String fileUnit,
					BufferedReader file,
					String line,
					StringTokenizer t)
    {
	try
	    {
		// the while structure deals with the empty lines case
		while (! t.hasMoreTokens())
		    {
			line = file.readLine();
			if (line==null)
			    {
				t=null;
				break;
			    }
			else
			    {
				line=line.replace('\t',' ');
				t = new StringTokenizer(line, " ");
			    }
		    }
	    }
       	catch (IOException e)
	    {
		System.out.println("IOException:" + e.toString());
	    }

	return t;
    }


}
