//  StartESFrame.java - jesevol application, Open Foundation version
//  Pietro Terna (start June 2004; this version September 2004)
//  Dipartimento di Scienze economiche e finanziarie G.Prato
//  Universit di Torino

//  Some Swarm building ideas and comments come from jHeatbugs (Java Heatbugs
//  application. Copyright  1999-2000 Swarm Development Group.)

import swarm.Globals;
import java.io.*;

/**
 * The StartESFrame class contains main().
 * We follow here the typical Swarm structure with main() (in Start...
 * as a convention) generating the Observer and the Observer
 * generating the Model.<br>
 *
 * @author Pietro Terna
 */
public class StartESFrame
    {
	/** the observer in our application */
	public static ESFrameObserverSwarm eSFrameObserverSwarm;

	/** being verbose? */
	public static boolean verbose;

	/**
	 * The main() function is the top-level place where everything starts.
	 */
	public static void main (String[] args) {


	    // Swarm initialization
	    Globals.env.initSwarm ("jesopenfoundation", "v.0.1.20", 
				   "pietro.terna@unito.it",args);

	    // creating the ESFrameObserverSwarm via lispAppArchiver, which
	    // refers to the jesopenfoundation.scm file where we can modify parameters
	    // in a stable way without recompile the interested class
	    eSFrameObserverSwarm =
		(ESFrameObserverSwarm) Globals.env.lispAppArchiver.getWithZone$key(
				       Globals.env.globalZone, "eSFrameObserverSwarm");
	    // instead of using the direct constructor way
	    // eSFrameObserverSwarm = new
	    //                      eSFrameObserverSwarm (Globals.env.globalZone);

	    // to save control panel position
	    Globals.env.setWindowGeometryRecordName
		(eSFrameObserverSwarm, "eSFrameObserverSwarm");
	    
	    // build objets into the obsever
	    eSFrameObserverSwarm.buildObjects ();
	    // verbose now is true/false, following the choice made
	    // in the Observer
	    
	    // build actions into the observer
	    eSFrameObserverSwarm.buildActions ();

	    // activate
	    eSFrameObserverSwarm.activateIn (null);

	    // go() in eSFrameObserver is a method inherited from class
	    // swarm.simtoolsgui.GUISwarmImpl
	    // go() start the activity running, and also handle user requests
	    // via the control panel.
	    eSFrameObserverSwarm.go();
	
	    // concluding the activity we drop the observer and then the model
	    // dropping the observer we use a redefined drop method, which
	    // starts with the 'getControlPanel ().setStateStopped ();' instruction
	    // necessary to avoid a Tcl error, appearing in W2000 and XP
	    // we have so to press Quit twice
	    eSFrameObserverSwarm.drop();
	}
}
